/*
    Copyright (C) 2005-2007  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _NNTPGRAB_REGEX_H_
#define _NNTPGRAB_REGEX_H_

#include <glib.h>
#include "nntpgrab.h"

#if !GLIB_CHECK_VERSION(2,14,0)
#include <pcre.h>
#define REGEX   pcre
#else
#define REGEX   GRegex
#endif

REGEX        *nntpgrab_utils_regex_compile(const char *regex);
void          nntpgrab_utils_regex_free(REGEX *re);
const char  **nntpgrab_utils_regex_match(REGEX *re, const char *line);
void          nntpgrab_utils_regex_matches_free(const char **matches);
gboolean      nntpgrab_utils_strip_subject(const char *subject, char **suffix, int *file_num, int *total_files, char **filename, char **extension, NNTPFileType *file_type, int *par2_startnum, int *num_par2_blocks, int *part_num, int *total_parts);
char         *nntpgrab_utils_calculate_file_size(guint64 file_size);
int           nntpgrab_utils_calculate_estimated_time_remaining(int bytes_received1, int bytes_received2, int bytes_received3, int bytes_received4, int bytes_received5, int bytes_received6, int bytes_received7, int bytes_received8, int bytes_received9, int bytes_received10, guint64 file_size);
char         *nntpgrab_utils_get_readable_time_remaining(int estimated_time_remaining);
char         *nntpgrab_utils_get_readable_finished_time(int estimated_time_remaining);

#endif /* _NNTPGRAB_REGEX_H_ */
